import { createFoundationSimulationServer, } from "@simulacrum/foundation-simulator";
import { extendStore } from "./store/index";
import { extendRouter } from "./extend-api";
import { openapi } from "./rest/index";
import { gitubInitialStoreSchema, } from "./store/entities";
export const simulation = (args = {}) => {
    var _a, _b, _c, _d;
    const parsedInitialState = !(args === null || args === void 0 ? void 0 : args.initialState)
        ? undefined
        : gitubInitialStoreSchema.parse(args === null || args === void 0 ? void 0 : args.initialState);
    return createFoundationSimulationServer({
        port: 3300, // default port
        simulationContextPage: "/simulation",
        extendStore: extendStore(parsedInitialState, (_a = args === null || args === void 0 ? void 0 : args.extend) === null || _a === void 0 ? void 0 : _a.extendStore),
        extendRouter,
        openapi: openapi(parsedInitialState, (_b = args === null || args === void 0 ? void 0 : args.apiUrl) !== null && _b !== void 0 ? _b : "/", (_c = args === null || args === void 0 ? void 0 : args.apiSchema) !== null && _c !== void 0 ? _c : "api.github.com.json", (_d = args === null || args === void 0 ? void 0 : args.extend) === null || _d === void 0 ? void 0 : _d.openapiHandlers),
    })();
};
export { githubUserSchema, githubOrganizationSchema, githubRepositorySchema, githubBranchSchema, githubBlobSchema, } from "./store/entities";
//# sourceMappingURL=index.js.map